// STypes.h: s.
//
//////////////////////////////////////////////////////////////////////

// This file defines types that can be used in other header files

#if !defined(AFX_GLBTYPES_H__3724B201_2C60_11D2_9A26_00403354E42C__INCLUDED_)
#define AFX_GLBTYPES_H__3724B201_2C60_11D2_9A26_00403354E42C__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define MIN_PLOT_X_PIXELS 100
#define MIN_PLOT_Y_PIXELS 80

#define MIN_FRAME_X_PIXELS 200
#define MIN_FRAME_Y_PIXELS 160

#define MAX_CHANNELS 0x4000ul
#define MAX_COUNTS 0xFFFFFFFFul

#define MIN_PLOT_CHANNELS 64
#define MIN_PLOT_COUNTS 32

#define MIN_GAIN 256
#define MAX_GAIN_INDEX 6

#define GAIN_FROM_INDEX(index) (MIN_GAIN << index)
#define GETULONG(d) ((unsigned long) floor(d + 0.5))
#define TOULONG(d) (d <= 0.0 ? 0 : \
        (d > ULONG_MAX ? ULONG_MAX : GETULONG(d)))
#define GETLONG(d) ((long) floor(d + 0.5))
#define TOLONG(d) (d <= LONG_MIN ? LONG_MIN : \
        (d > LONG_MAX ? LONG_MAX : GETLONG(d)))

#define SCREEN_SCALE 10000

#define MAX_SPECTRA 20


typedef enum
{
    LIN_SCALE,
    LOG_SCALE,
    SQRT_SCALE
} SCALE_TYPE;

typedef enum
{
    INVALID_SMOOTH = -2,
    NO_SMOOTH,
    THREE_SMOOTH,
    FIVE_SMOOTH
} SMOOTH_TYPE;

typedef enum
{
    GAIN_256,
    GAIN_512,
    GAIN_1024,
    GAIN_2048,
    GAIN_4096,
    GAIN_8192,
    GAIN_16384
} GAIN_TYPE;

#endif // !defined(AFX_GLBTYPES_H__3724B201_2C60_11D2_9A26_00403354E42C__INCLUDED_)
